with Rep_Ops;
use Rep_Ops;

package Error_Ops is

   type Error is private;
   Zero_Error, Unit_Error: constant Error;

   function Sup(E: Error) return Rep;
   function Err(R: Radius) return Error;

   function "+"(Left,Right: Error) return Error;
   function "*"(R: Rep; E: Error) return Error;
   function "*"(Left,Right: Error) return Error;
   function "**"(E1: Error; I: Natural) return Error;
   function "/"(E: Error; R: Rep) return Error;
   function "/"(E: Error; I: Integer) return Error;
   function Max(E1: Error; E2: Error) return Error;


private

   type Error is new Radius;
   Zero_Error: constant Error := Error(0);
   Unit_Error: constant Error := Error(1);

   --pragma Inline(Sup,Err,"+","*","/");

end Error_Ops;

