with Ada.Numerics.Generic_Elementary_Functions;

package body Rep_Ops is


   package Rep_IO is
      new Ada.Text_IO.Float_IO(Rep);
   package Rep_EF is
      new Ada.Numerics.Generic_Elementary_Functions(Rep);


   procedure Get(F: in File_Type; R: out Rep) is
   begin
      Rep_IO.Get(File=>F, Item=>R);
   end Get;


   procedure Put(F: in File_Type; R: in Rep; A: in Field := 16; E: in Field := 4) is
   begin
      Rep_IO.Put(File=>F, Item=>R, Aft=>A, Exp=>E);
   end Put;


   procedure ShowPair(Variable: in String; Value: in Rep) is
      type Approx is delta 0.0000000001 range -10000.0 .. 10000.0;
      package Approx_IO is new Ada.Text_IO.Fixed_IO(Approx);
   begin
      Put(Variable & " := ");
      Approx_IO.Put(Current_Output,Approx(Value));
      Put_Line(" ;");
   end ShowPair;


   function Min3(R1,R2,R3: Rep) return Rep is
   begin
      return Min(Min(R1,R2),R3);
   end Min3;


   function Max3(R1,R2,R3: Rep) return Rep is
   begin
      return Max(Max(R1,R2),R3);
   end Max3;


   function Sqrt(R: Rep) return Rep renames Rep_EF.Sqrt;
   function Cos(R: Rep) return Rep renames Rep_EF.Cos;
   function Sin(R: Rep) return Rep renames Rep_EF.Sin;
   function Log(R: Rep) return Rep renames Rep_EF.Log;
   function Cosh(R: Rep) return Rep renames Rep_EF.Cosh;
   function Sinh(R: Rep) return Rep renames Rep_EF.Sinh;
   function Exp(R: Rep) return Rep renames Rep_EF.Exp;

end Rep_Ops;
