with Ada.Text_IO;
use Ada.Text_IO;

package Rep_Ops is

   type Rep is new Long_Float;

   Zero: constant Rep := Rep(0);
   One:  constant Rep := Rep(1);
   Two:  constant Rep := Rep(2);
   Four: constant Rep := Rep(4);
   Five: constant Rep := Rep(5);
   Half: constant Rep := One/Two;
   Last: constant Rep := Rep'Last;

   procedure Get(F: in File_Type; R: out Rep);
   procedure Put(F: in File_Type; R: in Rep; A: in Field := 16; E: in Field := 4);
   procedure ShowPair(Variable: in String; Value: in Rep);

   function Succ(R: Rep) return Rep renames Rep'Succ;
   function Pred(R: Rep) return Rep renames Rep'Pred;

   function Min(R1,R2: Rep) return Rep renames Rep'Min;
   function Max(R1,R2: Rep) return Rep renames Rep'Max;
   function Min3(R1,R2,R3: Rep) return Rep;
   function Max3(R1,R2,R3: Rep) return Rep;

   function Sqrt(R: Rep) return Rep;
   function Cos(R: Rep) return Rep;
   function Sin(R: Rep) return Rep;
   function Log(R: Rep) return Rep;
   function Cosh(R: Rep) return Rep;
   function Sinh(R: Rep) return Rep;
   function Exp(R: Rep) return Rep;


   subtype Radius is Rep;       --- range Zero .. Last;

end Rep_Ops;

